#ifndef IBBR_GXConverterExport_H
#define IBBR_GXConverterExport_H
/* ****************************************************************

	(c) 2012  IBBR  b.rath@ibbr.de

  definiert die exportierten Funktione

  Autor: 

  ConverterRoutinen knnen generell auch direkt eingebunden werden
  d.h. ALLE Routinen intern mit WideString
  Stringbergabe intern nur mit pWideChar

  ACHTUNG: Strings gem. GAEB2000xml als UTF-8 an die DLL bergeben

  HISTORY
  18.03.2005     ReplaceString(S,'&','&amp;'); als erste replace Anweisung
                 in gtcAsciiAddLine()
                 checkTE() auch fr Kurztext impelementiert. Fehlte komplett
                 Bisher keine TE aus Ascii in KT mglich
                 asciitext: links<=>rechts war sonst fehlerhaft (Deussen)
  06.03.2005     DebugMessage in exception in html2gxmlUI() etc. hinzugefgt
  14.07.2004     gtcRtfAddAK hinzugefgt. Add Kurztext von Additional Text (seit GAEB 3.0)

  20.02.2012	Umstellung auf IBBR Routinen

  *****************************************************************/

#define _GTCDLL

#ifdef _GTCDLL

//  #define GTC_CLASS_DECL        __declspec( dllexport )
//  #define GTC_API_DECL          __declspec( dllexport )
  #define GTC_API_DECL          __stdcall

#else

#ifdef _GTCSTATIC

  #define GTC_CLASS_DECL       
  #define GTC_API_DECL         

#else

  #define GTC_CLASS_DECL        __declspec( dllimport )
  #define GTC_API_DECL          __declspec( dllimport )


  #ifdef _DEBUG     
      #pragma comment (lib, "IBBR_GXConverterD.lib")
  #else
      #pragma comment (lib, "IBBR_GXConverter.lib")
  #endif


#endif  // _GTCSTATIC
#endif  // _GTCDLL

extern "C" {

/* allgemein */
int GTC_API_DECL gtcConvCreate( int iCode ); 
int GTC_API_DECL gtcConvFree( const int iRef );

/*intern*/
int GTC_API_DECL gtcConvCreateIntern( int iCode, const bool fShowDemo, const int iCompany ); 

/*intern*/;
int GTC_API_DECL gtcConvCreateEx( int iCode, int iReserved ); 
int GTC_API_DECL gtcConvSetKt( const int iRef, const bool fIsKt ); /* deprecated */

// 2007-04-16,SD: neue Methoden fr die Versionierung
int GTC_API_DECL gtcGetVersion( );
int GTC_API_DECL gtcGetBuildVersion( const int iRef, char*& pszBuildVersion );

// 2007-08-20,SD: neue Methoden fr die GAEB-Versionierung
int GTC_API_DECL gtcConvSetGaebDaXmlVersion( const int iRef, const char* pszGaebDaXmlVersion );
int GTC_API_DECL gtcScaleImageToSize( const int iRef, bool ScaleImageToSize );

// 2008-09-15,SD: neue Methoden
int GTC_API_DECL gtcConvSetRtfFontNameF0( const int iRef, const char* pszRtfFontNameF0 );

/* ascii2gxml */
int GTC_API_DECL gtcAsciiClear( const int iRef );
int GTC_API_DECL gtcAsciiAddLineK( const int iRef, const char* ascii, const char cKind, const int iMarkLbl );
int GTC_API_DECL gtcAsciiAddLineL( const int iRef, const char* ascii, const char cKind, const int iMarkLbl );

// 2007-04-16,SD: zwei neue Methoden fr AddText
int GTC_API_DECL gtcAsciiAddLineAK( const int iRef, const char* ascii );
int GTC_API_DECL gtcAsciiAddLineAL( const int iRef, const char* ascii );

// 2007-04-16,SD: eine neue Methoden fr den Typ FText
int GTC_API_DECL gtcAsciiAddLineF( const int iRef, const char* ascii, const wchar_t* pwTargetTyp );

// 2007-04-16,SD: eine neue Methoden fr den Typ MLText
int GTC_API_DECL gtcAsciiAddLineML( const int iRef, const char* ascii, const wchar_t* pwTargetTyp );
int GTC_API_DECL gtcAscii2gxml( const int iRef, wchar_t*& pwBuf, wchar_t*& pwError );

// 2007-05-04,SD: zwei neue Methoden fr die Konvertierung von Ascii nach Kurztext bzw. Langtext
int GTC_API_DECL gtcAscii2gxmlK( const int iRef, wchar_t*& pwBuf, bool& fHasTA, wchar_t*& pwError );
int GTC_API_DECL gtcAscii2gxmlL( const int iRef, wchar_t*& pwBuf, bool& fHasTA, bool& fHasTB, wchar_t*& pwError );

/* ascii2rtf */
int GTC_API_DECL gtcAscii2RtfK( const int iRef, char*& pBuf, wchar_t*& pwError );
int GTC_API_DECL gtcAscii2RtfL( const int iRef, char*& pBuf, const bool fMakeWmf, wchar_t*& pwError );

/* gxml2ascii */
int GTC_API_DECL gtcGxml2Ascii( const int iRef, const wchar_t* gxml, wchar_t*& pwError, const int iMaxChar );
int GTC_API_DECL gtcAsciiGetLineK( const int iRef, char*& pBuf, char& cKind, int& iMarkLbl );
int GTC_API_DECL gtcAsciiGetLineL( const int iRef, char*& pBuf, char& cKind, int& iMarkLbl );

// 2007-04-16,SD: zwei neue Methoden fr AddText
int GTC_API_DECL gtcAsciiGetLineAK( const int iRef, char*& pBuf );
int GTC_API_DECL gtcAsciiGetLineAL( const int iRef, char*& pBuf );

// 2007-04-16,SD: eine neue Methoden fr den Typ FText
int GTC_API_DECL gtcAsciiGetLineF( const int iRef, char*& pBuf );

// 2007-04-16,SD: eine neue Methoden fr den Typ MLText
int GTC_API_DECL gtcAsciiGetLineML( const int iRef, char*& pBuf );
int GTC_API_DECL gtcAsciiGetStlbBauKey( const int iRef, char*& pBuf );

/* rtf2GXML */
int GTC_API_DECL gtcRtfAddK( const int iRef, char* rtfK );
int GTC_API_DECL gtcRtfAddL( const int iRef, char* rtfL );
int GTC_API_DECL gtcRtfAddAK( const int iRef, char* rtfAK );
int GTC_API_DECL gtcRtfAddA( const int iRef, char* rtfA );

// 2007-04-16,SD: eine neue Methoden fr den Typ FText
int GTC_API_DECL gtcRtfAddF( const int iRef, char* rtfF, const wchar_t* pwTargetTyp );

// 2007-04-16,SD: eine neue Methoden fr den Typ MLText
int GTC_API_DECL gtcRtfAddML( const int iRef, char* rtfML, const wchar_t* pwTargetTyp );
int GTC_API_DECL gtcRtf2gxmlSetInner( const int iRef, const bool fGetInnerXml );
int GTC_API_DECL gtcRtf2gxml( const int iRef, wchar_t*& pwBuf, wchar_t*& pwError, const bool fAddText );

// 27.04.2007, SD
int gtcRtf2gxmlF( const int iRef, wchar_t*& pwBuf, wchar_t*& pwError );
int gtcRtf2gxmlML( const int iRef, wchar_t*& pwBuf, wchar_t*& pwError );

// 2007-05-04,SD: zwei neue Methoden fr die Konvertierung von Rtf nach Kurztext bzw. Langtext
int GTC_API_DECL gtcRtf2gxmlK( const int iRef, wchar_t*& pwBuf, bool& fHasTA, wchar_t*& pwError );
int GTC_API_DECL gtcRtf2gxmlL( const int iRef, wchar_t*& pwBuf, bool& fHasTA, bool& fHasTB, wchar_t*& pwError );

/* rtf2Ascii */
int GTC_API_DECL gtcRtf2AsciiK( const int iRef, wchar_t*& pwError, const int iMaxChar );
int GTC_API_DECL gtcRtf2AsciiL( const int iRef, wchar_t*& pwError, const int iMaxChar );

/* gxml2RTF */
int GTC_API_DECL gtcGxml2RtfK( const int iRef, const wchar_t* gxml, char*& pBuf, wchar_t*& pwError );
int GTC_API_DECL gtcGxml2RtfL( const int iRef, const wchar_t* gxml, char*& pBuf, const bool fMakeWmf, wchar_t*& pwError );
int GTC_API_DECL gtcGxml2RtfSetDefaults( const int iRef, const wchar_t* sDefaults );

// 2007-04-16,SD: eine neue Methoden fr den Typ FText
int GTC_API_DECL gtcGxml2RtfF( const int iRef, const wchar_t* gxml, char*& pBuf, const bool fMakeWmf, wchar_t*& pwError );

// 2007-04-16,SD: eine neue Methoden fr den Typ MLText
int GTC_API_DECL gtcGxml2RtfML( const int iRef, const wchar_t* gxml, char*& pBuf, wchar_t*& pwError );

// 2010-03-10, SD eine neue Methoden fr die Konvertierung von 31 Nach 30
int GTC_API_DECL gtcConvertGxml31To30( const int iRef, const wchar_t* gxml, wchar_t*& pwBuf, wchar_t*& pwError );

// 2010-07-08, SD eine neue Methoden
int GTC_API_DECL gtcGetGxmlImgFromFile( const int iRef, const char* pszFilePath, const char* pszFileTyp, const wchar_t* pwTargetTyp, wchar_t*& pwBuf );


/* internal only */
int GTC_API_DECL gxml2HtmlUI( const int iRef, wchar_t* gxml, wchar_t*& pwBuf, const int Count, bool & fHasTextComplement, bool& fHasStlbBau, const unsigned char * wsImages, const int iReserved, int& nTextWidth );
int GTC_API_DECL html2gxmlUI( const int iRef, wchar_t* html, wchar_t*& pwBuf, const int Count, const int iReserved );

//nur intern

}

#endif //  IBBR_GXConverterExport_H